package server

import (
	"PD1/internal/protocol"
	"PD1/internal/utils/networking"
	"fmt"
)

func clientHandler(connection networking.Connection[protocol.Packet]) {
    defer connection.Conn.Close()

	for {
        pac := connection.Receive()
		switch pac.Flag {
		case protocol.ReqPK:
			fmt.Println("ReqPK")
		case protocol.ReqAllMsg:
			fmt.Println("ReqAllMsg")
		case protocol.ReqMsg:
			fmt.Println("ReqMsg")
		case protocol.SubmitMsg:
			fmt.Println("SubmitMsg")
		}
	}

}

func Run(port int) {
    server := networking.NewServer[protocol.Packet](port)  
    go server.ListenLoop()

	for {
		//Receive Connection via channel
		conn := <-server.C
		//Launch client handler via clientHandler
		go clientHandler(conn)
	}
}
